diff -ru extract/pidgin-2.10.9/libpurple/account.c libpurple/account.c
--- extract/pidgin-2.10.9/libpurple/account.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/account.c	2015-05-04 13:42:04.464970479 +0200
@@ -30,7 +30,6 @@
 #include "debug.h"
 #include "network.h"
 #include "notify.h"
-#include "pounce.h"
 #include "prefs.h"
 #include "privacy.h"
 #include "prpl.h"
@@ -41,6 +40,8 @@
 #include "util.h"
 #include "xmlnode.h"
 
+#define schedule_accounts_save()
+
 typedef struct
 {
 	PurpleConnectionErrorInfo *current_error;
@@ -89,6 +90,7 @@
 static void set_current_error(PurpleAccount *account,
 	PurpleConnectionErrorInfo *new_err);
 
+#if 0
 /*********************************************************************
  * Writing to disk                                                   *
  *********************************************************************/
@@ -961,6 +963,7 @@
 
 	return ret;
 }
+#endif
 
 static void
 load_accounts(void)
@@ -969,6 +972,7 @@
 
 	accounts_loaded = TRUE;
 
+#if 0
 	node = purple_util_read_xml_from_file("accounts.xml", _("accounts"));
 
 	if (node == NULL)
@@ -985,6 +989,7 @@
 	xmlnode_free(node);
 
 	_purple_buddy_icons_account_loaded_cb();
+#endif
 }
 
 
@@ -1097,8 +1102,10 @@
 
 	purple_presence_destroy(account->presence);
 
+#if 0
 	if(account->system_log)
 		purple_log_free(account->system_log);
+#endif
 
 	while (account->deny) {
 		g_free(account->deny->data);
@@ -1282,8 +1289,13 @@
 
 	gc = purple_account_get_connection(account);
 	_purple_connection_destroy(gc);
+
+	/* 
+	XXXFlo: disable this until the UI for requesting a password
+	        from the user works in Instantbird
 	if (!purple_account_get_remember_password(account))
 		purple_account_set_password(account, NULL);
+	*/
 	purple_account_set_connection(account, NULL);
 
 	account->disconnecting = FALSE;
@@ -1977,6 +1989,7 @@
 purple_account_set_int(PurpleAccount *account, const char *name, int value)
 {
 	PurpleAccountSetting *setting;
+	PurpleAccountUiOps *ui_ops;
 
 	g_return_if_fail(account != NULL);
 	g_return_if_fail(name    != NULL);
@@ -1988,6 +2001,11 @@
 
 	g_hash_table_insert(account->settings, g_strdup(name), setting);
 
+	ui_ops = purple_accounts_get_ui_ops();
+
+	if (ui_ops != NULL && ui_ops->set_int != NULL)
+		ui_ops->set_int(account, name, value);
+
 	schedule_accounts_save();
 }
 
@@ -1996,6 +2014,7 @@
 						const char *value)
 {
 	PurpleAccountSetting *setting;
+	PurpleAccountUiOps *ui_ops;
 
 	g_return_if_fail(account != NULL);
 	g_return_if_fail(name    != NULL);
@@ -2007,6 +2026,11 @@
 
 	g_hash_table_insert(account->settings, g_strdup(name), setting);
 
+	ui_ops = purple_accounts_get_ui_ops();
+
+	if (ui_ops != NULL && ui_ops->set_string != NULL)
+		ui_ops->set_string(account, name, value);
+
 	schedule_accounts_save();
 }
 
@@ -2014,6 +2038,7 @@
 purple_account_set_bool(PurpleAccount *account, const char *name, gboolean value)
 {
 	PurpleAccountSetting *setting;
+	PurpleAccountUiOps *ui_ops;
 
 	g_return_if_fail(account != NULL);
 	g_return_if_fail(name    != NULL);
@@ -2025,6 +2050,11 @@
 
 	g_hash_table_insert(account->settings, g_strdup(name), setting);
 
+	ui_ops = purple_accounts_get_ui_ops();
+
+	if (ui_ops != NULL && ui_ops->set_bool != NULL)
+		ui_ops->set_bool(account, name, value);
+
 	schedule_accounts_save();
 }
 
@@ -2204,7 +2234,7 @@
 
 	p = purple_find_prpl(purple_account_get_protocol_id(account));
 
-	return ((p && p->info->name) ? _(p->info->name) : _("Unknown"));
+	return ((p && p->info->name) ? p->info->name : _("Unknown"));
 }
 
 PurpleConnection *
@@ -2396,6 +2426,7 @@
 						const char *default_value)
 {
 	PurpleAccountSetting *setting;
+	const char *value;
 
 	g_return_val_if_fail(account != NULL, default_value);
 	g_return_val_if_fail(name    != NULL, default_value);
@@ -2407,7 +2438,11 @@
 
 	g_return_val_if_fail(setting->type == PURPLE_PREF_STRING, default_value);
 
-	return setting->value.string;
+	value = setting->value.string;
+	if (value == NULL || !*value)
+		return default_value;
+
+	return value;
 }
 
 gboolean
@@ -2495,6 +2530,7 @@
 	return setting->value.boolean;
 }
 
+#if 0
 PurpleLog *
 purple_account_get_log(PurpleAccount *account, gboolean create)
 {
@@ -2525,6 +2561,7 @@
 		account->system_log = NULL;
 	}
 }
+#endif
 
 void
 purple_account_add_buddy(PurpleAccount *account, PurpleBuddy *buddy)
@@ -2963,9 +3000,6 @@
 			purple_conversation_destroy(conv);
 	}
 
-	/* Remove this account's pounces */
-	purple_pounce_destroy_all_by_account(account);
-
 	/* This will cause the deletion of an old buddy icon. */
 	purple_buddy_icons_set_account_icon(account, NULL, 0);
 
@@ -3147,6 +3181,15 @@
 						 purple_marshal_VOID__POINTER, NULL, 1,
 						 purple_value_new(PURPLE_TYPE_SUBTYPE, PURPLE_SUBTYPE_ACCOUNT));
 
+	purple_signal_register(handle, "account-status-changing",
+						 purple_marshal_VOID__POINTER_POINTER_POINTER, NULL, 3,
+						 purple_value_new(PURPLE_TYPE_SUBTYPE,
+										PURPLE_SUBTYPE_ACCOUNT),
+						 purple_value_new(PURPLE_TYPE_SUBTYPE,
+										PURPLE_SUBTYPE_STATUS),
+						 purple_value_new(PURPLE_TYPE_SUBTYPE,
+										PURPLE_SUBTYPE_STATUS));
+
 	purple_signal_register(handle, "account-status-changed",
 						 purple_marshal_VOID__POINTER_POINTER_POINTER, NULL, 3,
 						 purple_value_new(PURPLE_TYPE_SUBTYPE,
@@ -3232,13 +3275,14 @@
 purple_accounts_uninit(void)
 {
 	gpointer handle = purple_accounts_get_handle();
+#if 0
 	if (save_timer != 0)
 	{
 		purple_timeout_remove(save_timer);
 		save_timer = 0;
 		sync_accounts();
 	}
-
+#endif
 	for (; accounts; accounts = g_list_delete_link(accounts, accounts))
 		purple_account_destroy(accounts->data);
 
diff -ru extract/pidgin-2.10.9/libpurple/account.h libpurple/account.h
--- extract/pidgin-2.10.9/libpurple/account.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/account.h	2015-05-04 13:42:04.464970479 +0200
@@ -115,6 +115,10 @@
 	 */
 	void (*close_account_request)(void *ui_handle);
 
+	void (*set_int)(PurpleAccount *account, const char *name, int value);
+	void (*set_string)(PurpleAccount *account, const char *name, const char *value);
+	void (*set_bool)(PurpleAccount *account, const char *name, gboolean value);
+
 	void (*_purple_reserved1)(void);
 	void (*_purple_reserved2)(void);
 	void (*_purple_reserved3)(void);
@@ -944,14 +948,14 @@
  *       if the log has already been closed, which not all loggers deal
  *       with appropriately.
  */
-PurpleLog *purple_account_get_log(PurpleAccount *account, gboolean create);
+/* PurpleLog *purple_account_get_log(PurpleAccount *account, gboolean create); */
 
 /**
  * Frees the system log of an account
  *
  * @param account The account.
  */
-void purple_account_destroy_log(PurpleAccount *account);
+/* void purple_account_destroy_log(PurpleAccount *account); */
 
 /**
  * Adds a buddy to the server-side buddy list for the specified account.
diff -ru extract/pidgin-2.10.9/libpurple/blist.c libpurple/blist.c
--- extract/pidgin-2.10.9/libpurple/blist.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/blist.c	2015-05-04 13:42:04.464970479 +0200
@@ -28,7 +28,6 @@
 #include "dbus-maybe.h"
 #include "debug.h"
 #include "notify.h"
-#include "pounce.h"
 #include "prefs.h"
 #include "privacy.h"
 #include "prpl.h"
@@ -126,6 +125,7 @@
 }
 
 
+#if 0
 /*********************************************************************
  * Writing to disk                                                   *
  *********************************************************************/
@@ -600,15 +600,19 @@
 			parse_chat(group, cnode);
 	}
 }
+#endif
 
 /* TODO: Make static and rename to load_blist */
 void
 purple_blist_load()
 {
+#if 0
 	xmlnode *purple, *blist, *privacy;
+#endif
 
 	blist_loaded = TRUE;
 
+#if 0
 	purple = purple_util_read_xml_from_file("blist.xml", _("buddy list"));
 
 	if (purple == NULL)
@@ -670,6 +674,7 @@
 
 	/* This tells the buddy icon code to do its thing. */
 	_purple_buddy_icons_blist_loaded_cb();
+#endif
 }
 
 
@@ -1623,8 +1628,10 @@
 		((PurpleContact*)bnode->parent)->totalsize--;
 		/* the group totalsize will be taken care of by remove_contact below */
 
-		if (bnode->parent->parent != (PurpleBlistNode*)g)
+		if (bnode->parent->parent != (PurpleBlistNode*)g) {
+			purple_signal_emit(purple_blist_get_handle(), "buddy-removed-from-group", buddy);
 			serv_move_buddy(buddy, (PurpleGroup *)bnode->parent->parent, g);
+		}
 
 		if (bnode->next)
 			bnode->next->prev = bnode->prev;
@@ -2185,9 +2192,6 @@
 	if (ops && ops->remove_node)
 		ops->remove_node(node);
 
-	/* Remove this buddy's pounces */
-	purple_pounce_destroy_all_by_buddy(buddy);
-
 	/* Signal that the buddy has been removed before freeing the memory for it */
 	purple_signal_emit(purple_blist_get_handle(), "buddy-removed", buddy);
 
@@ -3091,7 +3095,7 @@
 
 	if (!ops)
 		return;
-
+#if 0
 	if (!ops->save_node) {
 		ops->save_node = purple_blist_save_node;
 		overrode = TRUE;
@@ -3111,6 +3115,7 @@
 		purple_debug_warning("blist", "Only some of the blist saving UI ops "
 				"were overridden. This probably is not what you want!\n");
 	}
+#endif
 }
 
 PurpleBlistUiOps *
@@ -3192,6 +3197,11 @@
 						 purple_value_new(PURPLE_TYPE_SUBTYPE,
 										PURPLE_SUBTYPE_BLIST_BUDDY));
 
+	purple_signal_register(handle, "buddy-removed-from-group",
+						 purple_marshal_VOID__POINTER, NULL, 1,
+						 purple_value_new(PURPLE_TYPE_SUBTYPE,
+										PURPLE_SUBTYPE_BLIST_BUDDY));
+
 	purple_signal_register(handle, "buddy-icon-changed",
 						 purple_marshal_VOID__POINTER, NULL, 1,
 						 purple_value_new(PURPLE_TYPE_SUBTYPE,
@@ -3238,11 +3248,13 @@
 	if (purplebuddylist == NULL)
 		return;
 
+#if 0
 	if (save_timer != 0) {
 		purple_timeout_remove(save_timer);
 		save_timer = 0;
 		purple_blist_sync();
 	}
+#endif
 
 	purple_blist_destroy();
 
diff -ru extract/pidgin-2.10.9/libpurple/blist.h libpurple/blist.h
--- extract/pidgin-2.10.9/libpurple/blist.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/blist.h	2015-05-04 13:42:04.468970479 +0200
@@ -106,9 +106,35 @@
  */
 #define PURPLE_CHAT(obj) ((PurpleChat *)(obj))
 
+#if 0
+#include "media.h"
+#else
+/** extracted from media.h */
+/** Media caps */
+typedef enum {
+	PURPLE_MEDIA_CAPS_NONE = 0,
+	PURPLE_MEDIA_CAPS_AUDIO = 1,
+	PURPLE_MEDIA_CAPS_AUDIO_SINGLE_DIRECTION = 1 << 1,
+	PURPLE_MEDIA_CAPS_VIDEO = 1 << 2,
+	PURPLE_MEDIA_CAPS_VIDEO_SINGLE_DIRECTION = 1 << 3,
+	PURPLE_MEDIA_CAPS_AUDIO_VIDEO = 1 << 4,
+	PURPLE_MEDIA_CAPS_MODIFY_SESSION = 1 << 5,
+	PURPLE_MEDIA_CAPS_CHANGE_DIRECTION = 1 << 6
+} PurpleMediaCaps;
+
+/** Media session types */
+typedef enum {
+	PURPLE_MEDIA_NONE	= 0,
+	PURPLE_MEDIA_RECV_AUDIO = 1 << 0,
+	PURPLE_MEDIA_SEND_AUDIO = 1 << 1,
+	PURPLE_MEDIA_RECV_VIDEO = 1 << 2,
+	PURPLE_MEDIA_SEND_VIDEO = 1 << 3,
+	PURPLE_MEDIA_AUDIO = PURPLE_MEDIA_RECV_AUDIO | PURPLE_MEDIA_SEND_AUDIO,
+	PURPLE_MEDIA_VIDEO = PURPLE_MEDIA_RECV_VIDEO | PURPLE_MEDIA_SEND_VIDEO
+} PurpleMediaSessionType;
+#endif
 #include "account.h"
 #include "buddyicon.h"
-#include "media.h"
 #include "status.h"
 
 /**************************************************************************/
@@ -1088,7 +1114,7 @@
  * the buddy list is saved automatically, so you should not need to
  * call this.
  */
-void purple_blist_schedule_save(void);
+/* void purple_blist_schedule_save(void); */
 
 /**
  * Requests from the user information needed to add a buddy to the
diff -ru extract/pidgin-2.10.9/libpurple/buddyicon.c libpurple/buddyicon.c
--- extract/pidgin-2.10.9/libpurple/buddyicon.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/buddyicon.c	2015-05-04 13:42:04.468970479 +0200
@@ -187,6 +187,9 @@
 
 	g_return_if_fail(filename != NULL);
 
+	if (!purple_buddy_icons_is_caching())
+		return;
+
 	/* It's possible that there are other references to this icon
 	 * cache file that are not currently loaded into memory. */
 	if (GPOINTER_TO_INT(g_hash_table_lookup(icon_file_cache, filename)))
@@ -1123,31 +1126,34 @@
 }
 
 void
-_purple_buddy_icons_account_loaded_cb()
+purple_buddy_icons_account_loaded(PurpleAccount *account)
 {
-	const char *dirname = purple_buddy_icons_get_cache_dir();
-	GList *cur;
+	const char *account_icon_file = purple_account_get_string(account, "buddy_icon", NULL);
 
-	for (cur = purple_accounts_get_all(); cur != NULL; cur = cur->next)
+	if (account_icon_file != NULL)
 	{
-		PurpleAccount *account = cur->data;
-		const char *account_icon_file = purple_account_get_string(account, "buddy_icon", NULL);
-
-		if (account_icon_file != NULL)
+		const char *dirname = purple_buddy_icons_get_cache_dir();
+		char *path = g_build_filename(dirname, account_icon_file, NULL);
+		if (!g_file_test(path, G_FILE_TEST_EXISTS))
 		{
-			char *path = g_build_filename(dirname, account_icon_file, NULL);
-			if (!g_file_test(path, G_FILE_TEST_EXISTS))
-			{
-				purple_account_set_string(account, "buddy_icon", NULL);
-			} else {
-				ref_filename(account_icon_file);
-			}
-			g_free(path);
+			purple_account_set_string(account, "buddy_icon", NULL);
+		} else {
+			ref_filename(account_icon_file);
 		}
+		g_free(path);
 	}
 }
 
 void
+_purple_buddy_icons_account_loaded_cb()
+{
+	GList *cur;
+
+	for (cur = purple_accounts_get_all(); cur != NULL; cur = cur->next)
+		purple_buddy_icons_account_loaded(cur->data);
+}
+
+void
 _purple_buddy_icons_blist_loaded_cb()
 {
 	PurpleBlistNode *node = purple_blist_get_root();
diff -ru extract/pidgin-2.10.9/libpurple/buddyicon.h libpurple/buddyicon.h
--- extract/pidgin-2.10.9/libpurple/buddyicon.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/buddyicon.h	2015-05-04 13:42:04.468970479 +0200
@@ -270,6 +270,17 @@
 purple_buddy_icons_get_account_icon_timestamp(PurpleAccount *account);
 
 /**
+ * References the current icon of the loaded account.
+ *
+ * UIs should call this after loading an account, if the accounts
+ * aren't stored in the accounts.xml libpurple file.
+ *
+ * @param account The account
+ */
+void
+purple_buddy_icons_account_loaded(PurpleAccount *account);
+
+/**
  * Returns a boolean indicating if a given blist node has a custom buddy icon.
  *
  * @param node The blist node.
Only in extract/pidgin-2.10.9/libpurple: certificate.c
Only in extract/pidgin-2.10.9/libpurple: certificate.h
diff -ru extract/pidgin-2.10.9/libpurple/cmds.c libpurple/cmds.c
--- extract/pidgin-2.10.9/libpurple/cmds.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/cmds.c	2015-05-04 13:42:04.476970478 +0200
@@ -27,10 +27,11 @@
 #include "util.h"
 #include "cmds.h"
 
+static PurpleCommandsUiOps *cmds_ui_ops = NULL;
 static GList *cmds = NULL;
 static guint next_id = 1;
 
-typedef struct _PurpleCmd {
+struct _PurpleCmd {
 	PurpleCmdId id;
 	gchar *cmd;
 	gchar *args;
@@ -40,7 +41,7 @@
 	PurpleCmdFunc func;
 	gchar *help;
 	void *data;
-} PurpleCmd;
+};
 
 
 static gint cmds_compare_func(const PurpleCmd *a, const PurpleCmd *b)
@@ -59,6 +60,7 @@
 {
 	PurpleCmdId id;
 	PurpleCmd *c;
+	PurpleCommandsUiOps *ops;
 
 	g_return_val_if_fail(cmd != NULL && *cmd != '\0', 0);
 	g_return_val_if_fail(args != NULL, 0);
@@ -79,6 +81,10 @@
 
 	cmds = g_list_insert_sorted(cmds, c, (GCompareFunc)cmds_compare_func);
 
+	ops = purple_cmds_get_ui_ops();
+	if (ops && ops->register_command)
+		ops->register_command(cmd, p, f, prpl_id, helpstr, c);
+
 	purple_signal_emit(purple_cmds_get_handle(), "cmd-added", cmd, p, f);
 
 	return id;
@@ -102,6 +108,10 @@
 		c = l->data;
 
 		if (c->id == id) {
+			PurpleCommandsUiOps *ops = purple_cmds_get_ui_ops();
+			if (ops && ops->unregister_command)
+				ops->unregister_command(c->cmd, c->prpl_id);
+
 			cmds = g_list_remove(cmds, c);
 			purple_signal_emit(purple_cmds_get_handle(), "cmd-removed", c->cmd);
 			purple_cmd_free(c);
@@ -301,6 +311,39 @@
 
 }
 
+gboolean purple_cmd_execute(PurpleCmd *c, PurpleConversation *conv,
+			    const gchar *cmdline)
+{
+	gchar *err = NULL;
+	gchar **args = NULL;
+	PurpleCmdRet ret = PURPLE_CMD_RET_CONTINUE;
+
+	if (purple_conversation_get_type(conv) == PURPLE_CONV_TYPE_IM) {
+		if (!(c->flags & PURPLE_CMD_FLAG_IM))
+			return FALSE;
+	}
+	else if (purple_conversation_get_type(conv) == PURPLE_CONV_TYPE_CHAT) {
+		if (!(c->flags & PURPLE_CMD_FLAG_CHAT))
+			return FALSE;
+	}
+	else
+		return FALSE;
+
+	/* XXX: Don't worry much about the markup version of the command
+	   line, there's not a single use case... */
+	/* this checks the allow bad args flag for us */
+	if (!purple_cmd_parse_args(c, cmdline, cmdline, &args)) {
+		g_strfreev(args);
+		return FALSE;
+	}
+
+	ret = c->func(conv, c->cmd, args, &err, c->data);
+
+	g_free(err);
+	g_strfreev(args);
+
+	return ret == PURPLE_CMD_RET_OK;
+}
 
 GList *purple_cmd_list(PurpleConversation *conv)
 {
@@ -368,6 +411,21 @@
 	return &handle;
 }
 
+void
+purple_cmds_set_ui_ops(PurpleCommandsUiOps *ops)
+{
+	cmds_ui_ops = ops;
+}
+
+PurpleCommandsUiOps *
+purple_cmds_get_ui_ops(void)
+{
+	/* It is perfectly acceptable for cmds_ui_ops to be NULL; this just
+	 * means that the default libpurple implementation will be used.
+	 */
+	return cmds_ui_ops;
+}
+
 void purple_cmds_init(void)
 {
 	gpointer handle = purple_cmds_get_handle();
diff -ru extract/pidgin-2.10.9/libpurple/cmds.h libpurple/cmds.h
--- extract/pidgin-2.10.9/libpurple/cmds.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/cmds.h	2015-05-04 13:42:04.476970478 +0200
@@ -31,6 +31,8 @@
 /**************************************************************************/
 /*@{*/
 
+typedef struct _PurpleCmd PurpleCmd;
+
 /** The possible results of running a command with purple_cmd_do_command(). */
 typedef enum _PurpleCmdStatus {
 	PURPLE_CMD_STATUS_OK,
@@ -96,6 +98,31 @@
 	PURPLE_CMD_FLAG_ALLOW_WRONG_ARGS = 0x08
 } PurpleCmdFlag;
 
+/**
+ * Command UI operations;  UIs should implement this if they want to handle
+ * commands themselves, rather than relying on the core.
+ *
+ * @see @ref ui-ops
+ */
+typedef struct
+{
+	/** If implemented, the UI is responsible for handling commands. */
+	/* @see purple_cmd_register for the argument values. */
+	void (*register_command)(const gchar *name, PurpleCmdPriority p,
+				 PurpleCmdFlag f, const gchar *prpl_id,
+				 const gchar *helpstr, PurpleCmd *cmd);
+
+	/** Should be implemented if register_command is implemented.
+	 *  name and prpl_id should have the same value that were used
+	 *  for the register_command call.
+	 */
+	void (*unregister_command)(const gchar *name, const gchar *prpl_id);
+
+	void (*_purple_reserved1)(void);
+	void (*_purple_reserved2)(void);
+	void (*_purple_reserved3)(void);
+	void (*_purple_reserved4)(void);
+} PurpleCommandsUiOps;
 
 /*@}*/
 
@@ -194,6 +221,23 @@
                                   const gchar *markup, gchar **errormsg);
 
 /**
+ * Execute a specific command.
+ *
+ * The UI calls this to execute a command, after parsing the
+ * command name.
+ *
+ * @param c The command to execute.
+ * @param conv The conversation the command was typed in.
+ * @param cmdline The command the user typed (only the arguments).
+ *            The caller should remove the prefix and the command name.
+ *            It should not contain any formatting, and should be
+ *            in plain text (no html entities).
+ * @return TRUE if the command handled the cmdline, FALSE otherwise.
+ */
+gboolean purple_cmd_execute(PurpleCmd *c, PurpleConversation *conv,
+			    const gchar *cmdline);
+
+/**
  * List registered commands.
  *
  * Returns a <tt>GList</tt> (which must be freed by the caller) of all commands
@@ -230,6 +274,23 @@
 gpointer purple_cmds_get_handle(void);
 
 /**
+ * Sets the UI operations structure to be used when registering and
+ * unregistering commands.  The UI operations need only be set if the
+ * UI wants to handle the commands itself; otherwise, leave it as NULL.
+ *
+ * @param ops The UI operations structure.
+ */
+void purple_cmds_set_ui_ops(PurpleCommandsUiOps *ops);
+
+/**
+ * Returns the UI operations structure to be used when registering and
+ * unregistering commands.
+ *
+ * @return The UI operations structure.
+ */
+PurpleCommandsUiOps *purple_cmds_get_ui_ops(void);
+
+/**
  * Initialize the commands subsystem.
  * @since 2.5.0
  */
Only in libpurple: config.h
diff -ru extract/pidgin-2.10.9/libpurple/connection.c libpurple/connection.c
--- extract/pidgin-2.10.9/libpurple/connection.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/connection.c	2015-05-04 13:42:04.476970478 +0200
@@ -350,6 +350,7 @@
 		/* Set the time the account came online */
 		purple_presence_set_login_time(presence, time(NULL));
 
+#if 0
 		if (purple_prefs_get_bool("/purple/logging/log_system"))
 		{
 			PurpleLog *log = purple_account_get_log(account, TRUE);
@@ -365,6 +366,7 @@
 				g_free(msg);
 			}
 		}
+#endif
 
 		if (ops != NULL && ops->connected != NULL)
 			ops->connected(gc);
@@ -381,6 +383,7 @@
 	else if (gc->state == PURPLE_DISCONNECTED) {
 		PurpleAccount *account = purple_connection_get_account(gc);
 
+#if 0
 		if (purple_prefs_get_bool("/purple/logging/log_system"))
 		{
 			PurpleLog *log = purple_account_get_log(account, FALSE);
@@ -397,6 +400,7 @@
 		}
 
 		purple_account_destroy_log(account);
+#endif
 
 		if (ops != NULL && ops->disconnected != NULL)
 			ops->disconnected(gc);
diff -ru extract/pidgin-2.10.9/libpurple/conversation.c libpurple/conversation.c
--- extract/pidgin-2.10.9/libpurple/conversation.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/conversation.c	2015-05-04 13:42:04.480970478 +0200
@@ -153,6 +153,7 @@
 
 	type = purple_conversation_get_type(conv);
 
+#if 0
 	/* Always linkfy the text for display, unless we're
 	 * explicitly asked to do otheriwse*/
 	if (!(msgflags & PURPLE_MESSAGE_INVISIBLE)) {
@@ -167,6 +168,12 @@
 		sent = g_strdup(displayed);
 	} else
 		sent = g_strdup(message);
+#else
+	/* send and display as is, linkification has already been
+	   handled by the conversation binding */
+	displayed = g_strdup(message);
+	sent = g_strdup(message);
+#endif
 
 	msgflags |= PURPLE_MESSAGE_SEND;
 
@@ -238,6 +245,7 @@
 	g_free(sent);
 }
 
+#if 0
 static void
 open_log(PurpleConversation *conv)
 {
@@ -245,6 +253,7 @@
 							   PURPLE_LOG_IM, conv->name, conv->account,
 							   conv, time(NULL), NULL));
 }
+#endif
 
 /* Functions that deal with PurpleConvMessage */
 
@@ -307,8 +316,10 @@
 
 	account = purple_conversation_get_account(conv);
 
+#if 0
 	purple_conversation_close_logs(conv);
 	open_log(conv);
+#endif
 
 	gc = purple_account_get_connection(account);
 
@@ -398,11 +409,13 @@
 			purple_buddy_icon_unref(icon);
 		}
 
+#if 0
 		if (purple_prefs_get_bool("/purple/logging/log_ims"))
 		{
 			purple_conversation_set_logging(conv, TRUE);
 			open_log(conv);
 		}
+#endif
 	}
 	else if (type == PURPLE_CONV_TYPE_CHAT)
 	{
@@ -422,11 +435,13 @@
 			purple_conv_chat_set_nick(conv->u.chat,
 									purple_account_get_username(account));
 
+#if 0
 		if (purple_prefs_get_bool("/purple/logging/log_chats"))
 		{
 			purple_conversation_set_logging(conv, TRUE);
 			open_log(conv);
 		}
+#endif
 	}
 
 	conversations = g_list_prepend(conversations, conv);
@@ -598,7 +613,9 @@
 		ops->destroy_conversation(conv);
 	conv->ui_data = NULL;
 
+#if 0
 	purple_conversation_close_logs(conv);
+#endif
 
 	purple_conversation_clear_message_history(conv);
 
@@ -800,6 +817,7 @@
 	return conv->name;
 }
 
+#if 0
 void
 purple_conversation_set_logging(PurpleConversation *conv, gboolean log)
 {
@@ -829,6 +847,7 @@
 	g_list_free(conv->logs);
 	conv->logs = NULL;
 }
+#endif
 
 PurpleConvIm *
 purple_conversation_get_im_data(const PurpleConversation *conv)
@@ -1008,6 +1027,7 @@
 		}
 	}
 
+#if 0
 	if (!(flags & PURPLE_MESSAGE_NO_LOG) && purple_conversation_is_logging(conv)) {
 		GList *log;
 
@@ -1020,6 +1040,7 @@
 			log = log->next;
 		}
 	}
+#endif
 
 	if (ops && ops->write_conv)
 		ops->write_conv(conv, who, alias, displayed, flags, mtime);
@@ -1242,6 +1263,7 @@
 
 	if ((flags & PURPLE_MESSAGE_RECV) == PURPLE_MESSAGE_RECV) {
 		purple_conv_im_set_typing_state(im, PURPLE_NOT_TYPING);
+		purple_conv_im_update_typing(im);
 	}
 
 	/* Pass this on to either the ops structure or the default write func. */
diff -ru extract/pidgin-2.10.9/libpurple/conversation.h libpurple/conversation.h
--- extract/pidgin-2.10.9/libpurple/conversation.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/conversation.h	2015-05-04 13:42:04.480970478 +0200
@@ -568,7 +568,7 @@
  * @param conv The conversation.
  * @param log  @c TRUE if logging should be enabled, or @c FALSE otherwise.
  */
-void purple_conversation_set_logging(PurpleConversation *conv, gboolean log);
+/* void purple_conversation_set_logging(PurpleConversation *conv, gboolean log); */
 
 /**
  * Returns whether or not logging is enabled for this conversation.
@@ -577,7 +577,7 @@
  *
  * @return @c TRUE if logging is enabled, or @c FALSE otherwise.
  */
-gboolean purple_conversation_is_logging(const PurpleConversation *conv);
+/* gboolean purple_conversation_is_logging(const PurpleConversation *conv); */
 
 /**
  * Closes any open logs for this conversation.
@@ -588,7 +588,7 @@
  *
  * @param conv The conversation.
  */
-void purple_conversation_close_logs(PurpleConversation *conv);
+/* void purple_conversation_close_logs(PurpleConversation *conv); */
 
 /**
  * Returns the specified conversation's IM-specific data.
diff -ru extract/pidgin-2.10.9/libpurple/core.c libpurple/core.c
--- extract/pidgin-2.10.9/libpurple/core.c	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/core.c	2015-05-04 13:42:04.480970478 +0200
@@ -25,7 +25,6 @@
  */
 #include "internal.h"
 #include "cipher.h"
-#include "certificate.h"
 #include "cmds.h"
 #include "connection.h"
 #include "conversation.h"
@@ -38,19 +37,14 @@
 #include "network.h"
 #include "notify.h"
 #include "plugin.h"
-#include "pounce.h"
 #include "prefs.h"
 #include "privacy.h"
 #include "proxy.h"
-#include "savedstatuses.h"
 #include "signals.h"
 #include "smiley.h"
-#include "sound.h"
-#include "sound-theme-loader.h"
 #include "sslconn.h"
 #include "status.h"
 #include "stun.h"
-#include "theme-manager.h"
 #include "util.h"
 
 #ifdef HAVE_DBUS
@@ -63,6 +57,8 @@
 #  include "dbus-bindings.h"
 #endif
 
+#include <libxml/parser.h>
+
 struct PurpleCore
 {
 	char *ui;
@@ -73,7 +69,9 @@
 static PurpleCoreUiOps *_ops  = NULL;
 static PurpleCore      *_core = NULL;
 
+#ifdef STATIC_PROTO_INIT
 STATIC_PROTO_INIT
+#endif
 
 gboolean
 purple_core_init(const char *ui)
@@ -117,8 +115,6 @@
 	 * for protocol prefs to work. */
 	purple_prefs_init();
 
-	purple_debug_init();
-
 	if (ops != NULL)
 	{
 		if (ops->ui_prefs_init != NULL)
@@ -140,12 +136,15 @@
 	 */
 	purple_plugins_init();
 
+#ifdef STATIC_PROTO_INIT
 	/* Initialize all static protocols. */
 	static_proto_init();
+#endif
 
-	purple_plugins_probe(G_MODULE_SUFFIX);
+	if (ops != NULL && ops->register_plugins != NULL)
+		ops->register_plugins();
 
-	purple_theme_manager_init();
+	purple_plugins_probe(G_MODULE_SUFFIX);
 
 	/* The buddy icon code uses the imgstore, so init it early. */
 	purple_imgstore_init();
@@ -158,18 +157,14 @@
 	purple_connections_init();
 
 	purple_accounts_init();
-	purple_savedstatuses_init();
 	purple_notify_init();
-	purple_certificate_init();
 	purple_conversations_init();
 	purple_blist_init();
 	purple_log_init();
 	purple_network_init();
 	purple_privacy_init();
-	purple_pounces_init();
 	purple_proxy_init();
 	purple_dnsquery_init();
-	purple_sound_init();
 	purple_ssl_init();
 	purple_stun_init();
 	purple_xfers_init();
@@ -184,9 +179,6 @@
 	if (ops != NULL && ops->ui_init != NULL)
 		ops->ui_init();
 
-	/* The UI may have registered some theme types, so refresh them */
-	purple_theme_manager_refresh();
-
 	return TRUE;
 }
 
@@ -204,6 +196,7 @@
 	/* Transmission ends */
 	purple_connections_disconnect_all();
 
+#if 0
 	/*
 	 * Certificates must be destroyed before the SSL plugins, because
 	 * PurpleCertificates contain pointers to PurpleCertificateSchemes,
@@ -211,6 +204,7 @@
 	 * SSL plugin is uninit.
 	 */
 	purple_certificate_uninit();
+#endif
 
 	/* The SSL plugins must be uninit before they're unloaded */
 	purple_ssl_uninit();
@@ -223,18 +217,14 @@
 	/* Save .xml files, remove signals, etc. */
 	purple_smileys_uninit();
 	purple_idle_uninit();
-	purple_pounces_uninit();
 	purple_blist_uninit();
 	purple_ciphers_uninit();
 	purple_notify_uninit();
 	purple_conversations_uninit();
 	purple_connections_uninit();
 	purple_buddy_icons_uninit();
-	purple_savedstatuses_uninit();
 	purple_status_uninit();
 	purple_accounts_uninit();
-	purple_sound_uninit();
-	purple_theme_manager_uninit();
 	purple_xfers_uninit();
 	purple_proxy_uninit();
 	purple_dnsquery_uninit();
@@ -271,6 +261,8 @@
 	wpurple_cleanup();
 #endif
 
+        xmlCleanupParser();
+
 	_core = NULL;
 }
 
@@ -403,6 +395,7 @@
 	return TRUE;
 }
 
+#if 0
 gboolean
 purple_core_migrate(void)
 {
@@ -750,6 +743,7 @@
 	g_free(status_file);
 	return TRUE;
 }
+#endif
 
 GHashTable* purple_core_get_ui_info() {
 	PurpleCoreUiOps *ops = purple_core_get_ui_ops();
diff -ru extract/pidgin-2.10.9/libpurple/core.h libpurple/core.h
--- extract/pidgin-2.10.9/libpurple/core.h	2014-02-02 22:29:17.000000000 +0100
+++ libpurple/core.h	2015-05-04 13:42:04.480970478 +0200
@@ -71,6 +71,11 @@
 	 */
 	GHashTable* (*get_ui_info)(void);
 
+	/** Called during the initialization of the core to give the
+	 *  UI a chance to register static plugins.
+	 */
+	void (*register_plugins)(void);
+
 	void (*_purple_reserved1)(void);
 	void (*_purple_reserved2)(void);
 	void (*_purple_reserved3)(void);
@@ -164,7 +169,7 @@
  * @return A boolean indicating success or migration failure. On failure,
  *         the application must display an error to the user and then exit.
  */
-gboolean purple_core_migrate(void);
+/* gboolean purple_core_migrate(void); */
 
 /**
  * Ensures that only one instance is running.  If libpurple is built with D-Bus
Only in extract/pidgin-2.10.9/libpurple: dbus-analyze-functions.py
Only in extract/pidgin-2.10.9/libpurple: dbus-analyze-signals.py
Only in extract/pidgin-2.10.9/libpurple: dbus-analyze-types.py
Only in extract/pidgin-2.10.9/libpurple: dbus-bindings.h
Only in extract/pidgin-2.10.9/libpurple: dbus-define-api.h
Only in extract/pidgin-2.10.9/libpurple: dbus-purple.h
Only in extract/pidgin-2.10.9/libpurple: dbus-server.c
Only in extract/pidgin-2.10.9/libpurple: dbus-server.h
Only in extract/pidgin-2.10.9/libpurple: dbus-types.h
Only in extract/pidgin-2.10.9/libpurple: dbus-useful.c
Only in extract/pidgin-2.10.9/libpurple: dbus-useful.h
